package gregapi.enchants;

import gregapi.config.Config;
import gregapi.config.ConfigCategories;
import gregapi.data.LH;
import gregapi.data.MT;
import net.minecraft.enchantment.EnchantmentDamage;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.monster.EntitySlime;
import net.minecraft.potion.Potion;
import net.minecraft.potion.PotionEffect;

/**
 * @author Gregorius Techneticies
 */
public class Enchantment_SlimeDamage extends EnchantmentDamage {
	public static Enchantment_SlimeDamage INSTANCE;
	
	public Enchantment_SlimeDamage() {
		super(Config.addIDConfig(ConfigCategories.IDs.enchantments, "Dissolving", 13), 2, -1);
		LH.add(getName(), "Dissolving");
		MT.RockSalt			.addEnchantmentForTools(this, 2);
		MT.IodineSalt		.addEnchantmentForTools(this, 3);
		MT.Salt				.addEnchantmentForTools(this, 3);
		MT.Cu				.addEnchantmentForTools(this, 3);
		MT.AnnealedCopper	.addEnchantmentForTools(this, 4);
		MT.Hepatizon		.addEnchantmentForTools(this, 5);
		MT.Vyroxeres		.addEnchantmentForTools(this, 5);
		INSTANCE = this;
	}
	
    @Override
	public int getMinEnchantability(int aLevel) {
        return 5 + (aLevel - 1) * 8;
    }
    
    @Override
	public int getMaxEnchantability(int aLevel) {
        return this.getMinEnchantability(aLevel) + 20;
    }
    
    @Override
	public int getMaxLevel() {
        return 5;
    }
    
    @Override
	public void func_151367_b(EntityLivingBase aHurtEntity, Entity aDamagingEntity, int aLevel) {
        if (aHurtEntity instanceof EntitySlime || (aHurtEntity.getClass().getName().indexOf(".") >= 0 && aHurtEntity.getClass().getName().substring(aHurtEntity.getClass().getName().lastIndexOf(".")).contains("Slime"))) {
        	aHurtEntity.addPotionEffect(new PotionEffect(Potion.weakness.id	, aLevel * 200, Math.max(1, (5*aLevel) / 7)));
        	aHurtEntity.addPotionEffect(new PotionEffect(Potion.poison.id	, aLevel * 200, Math.max(1, (5*aLevel) / 7)));
        }
    }
    
    @Override
	public String getName() {
        return "enchantment.damage.slime";
    }
}