package gregapi.item;

import static gregapi.data.CS.ERR;
import static gregapi.data.CS.OUT;
import static gregapi.data.CS.W;
import gregapi.GT_API;
import gregapi.api.Abstract_Mod;
import gregapi.data.CS.OreDictToolNames;
import gregapi.data.MD;
import gregapi.data.MT;
import gregapi.lang.LanguageHandler;
import gregapi.recipes.GT_ModHandler;
import gregapi.recipes.GT_ModHandler.RecipeBits;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 */
public class ItemIntegratedCircuit extends ItemBase {
	public ItemIntegratedCircuit(String aUnlocalized, String aEnglish) {
		super(MD.GAPI.mID, aUnlocalized, aEnglish, "");
		setHasSubtypes(true);
        setMaxDamage(0);
        
		// TODO:
		GT_ModHandler.addShapelessCraftingRecipe(UT.Stacks.make(this, 1, 0), RecipeBits.DEFAULT, new Object[] {MT.DATA.CIRCUITS[1], OreDictToolNames.screwdriver/*, OreDictToolNames.solderingiron, OreDictToolNames.solderingmetal*/});
		
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 1), RecipeBits.DEFAULT, new Object[] {"d  ", " P ", "   ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 2), RecipeBits.DEFAULT, new Object[] {" d ", " P ", "   ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 3), RecipeBits.DEFAULT, new Object[] {"  d", " P ", "   ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 4), RecipeBits.DEFAULT, new Object[] {"   ", " Pd", "   ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 5), RecipeBits.DEFAULT, new Object[] {"   ", " P ", "  d", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 6), RecipeBits.DEFAULT, new Object[] {"   ", " P ", " d ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 7), RecipeBits.DEFAULT, new Object[] {"   ", " P ", "d  ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 8), RecipeBits.DEFAULT, new Object[] {"   ", "dP ", "   ", 'P', UT.Stacks.make(this, 1, W)});
		
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 9), RecipeBits.DEFAULT, new Object[] {"P d", "   ", "   ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,10), RecipeBits.DEFAULT, new Object[] {"P  ", "  d", "   ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,11), RecipeBits.DEFAULT, new Object[] {"P  ", "   ", "  d", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,12), RecipeBits.DEFAULT, new Object[] {"P  ", "   ", " d ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,13), RecipeBits.DEFAULT, new Object[] {"  P", "   ", "  d", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,14), RecipeBits.DEFAULT, new Object[] {"  P", "   ", " d ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,15), RecipeBits.DEFAULT, new Object[] {"  P", "   ", "d  ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,16), RecipeBits.DEFAULT, new Object[] {"  P", "d  ", "   ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,17), RecipeBits.DEFAULT, new Object[] {"   ", "   ", "d P", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,18), RecipeBits.DEFAULT, new Object[] {"   ", "d  ", "  P", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,19), RecipeBits.DEFAULT, new Object[] {"d  ", "   ", "  P", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,20), RecipeBits.DEFAULT, new Object[] {" d ", "   ", "  P", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,21), RecipeBits.DEFAULT, new Object[] {"d  ", "   ", "P  ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,22), RecipeBits.DEFAULT, new Object[] {" d ", "   ", "P  ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,23), RecipeBits.DEFAULT, new Object[] {"  d", "   ", "P  ", 'P', UT.Stacks.make(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1,24), RecipeBits.DEFAULT, new Object[] {"   ", "  d", "P  ", 'P', UT.Stacks.make(this, 1, W)});
	}
	
	@Override
	public void addAdditionalToolTips(List aList, ItemStack aStack, boolean aF3_H) {
		super.addAdditionalToolTips(aList, aStack, aF3_H);
		aList.add(LanguageHandler.get(getUnlocalizedName() + ".configuration", "Configuration: ") + getConfigurationString(getDamage(aStack)));
    }
	
	@Override
	public String getUnlocalizedName(ItemStack aStack) {
		return getUnlocalizedName();
	}
	
	@Override
    @SideOnly(Side.CLIENT)
    public final void getSubItems(Item var1, CreativeTabs aCreativeTab, List aList) {
        aList.add(UT.Stacks.make(this, 1, 0));
    }
	
	@Override
    @SideOnly(Side.CLIENT)
    public void registerIcons(IIconRegister aIconRegister) {
		super.registerIcons(aIconRegister);
		// Useful hack to register Item Icons. That is why the Integrated Circuit Item has to exist always.
		if (Abstract_Mod.sFinalized >= Abstract_Mod.sModCountUsingGTAPI) {
			OUT.println("GT_API: Setting up Icon Register for Items");
			GT_API.sItemIcons = aIconRegister;
			OUT.println("GT_API: Starting Item Icon Load Phase");
	    	for (Runnable tRunnable : GT_API.sItemIconload) {
	    		try {
	    			tRunnable.run();
	    		} catch(Throwable e) {
	    			e.printStackTrace(ERR);
	    		}
	    	}
			OUT.println("GT_API: Finished Item Icon Load Phase");
		}
    }
	
	private static String getModeString(int aMetaData) {
		switch ((byte)(aMetaData >>> 8)) {
		case  0: return "==";
		case  1: return "<=";
		case  2: return ">=";
		case  3: return "<";
		case  4: return ">";
		default: return "";
		}
	}
	
	private static String getConfigurationString(int aMetaData) {
		return getModeString(aMetaData) + " " + (byte)(aMetaData & 255);
	}
}